package hex;

import org.relaxng.datatype.*;
import org.relaxng.datatype.helpers.StreamingValidatorImpl;

public class HexType implements Datatype {
	public HexType( int _min, int _max ) {
		this.min = _min;
		this.max = _max;
	}
	
	// l̏Ɖ
	private final int min,max;
	
    public void checkValid( String s, ValidationContext vc ) throws DatatypeException {
		if(!isValid(s,vc))
			throw new DatatypeException();
    }
    public int getIdType() { return Datatype.ID_TYPE_NULL; }
    public boolean isContextDependent() { return false; }
    
    public DatatypeStreamingValidator createStreamingValidator(ValidationContext vc) {
        return new StreamingValidatorImpl(this,vc);
    }
    
	
    public boolean sameValue(Object o1,Object o2) {
        return o1.equals(o2);
    }
	
    public int valueHashCode(Object o) {
        return o.hashCode();
    }
    
    
	
	public static int parseHex( String s ) {
		int v=0;
		s = s.trim();	// Ő󔒂𗎂Ƃ
		for( int i=0; i<s.length(); i++ ) {
			v *= 16;
			char ch = s.charAt(i);
			if('0'<=ch && ch<='9') { v+= ch-'0';    continue; }
			if('a'<=ch && ch<='f') { v+= ch-'a'+10; continue; }
			if('A'<=ch && ch<='F') { v+= ch-'A'+10; continue; }
			return -1;	// lȂ
		}
		return v;
	}
	
    public boolean isValid( String s, ValidationContext vc ) {
		int v = parseHex(s);
		return min<=v && v<=max;
    }
    public Object createValue(String str,ValidationContext vc) {
        int v = parseHex(str);
		if(min<=v && v<=max)	return new Integer(v);
		else					return null;
    }
}
