package hex;

import org.relaxng.datatype.*;

public class HexTypeBuilder implements DatatypeBuilder
{
    private int min=0;
    private int max=Integer.MAX_VALUE;
    
    public Datatype createDatatype() {
        return new HexType(min,max);
    }
    
    public void addParameter(String name,String value,ValidationContext vc)
            throws DatatypeException {
        if(name.equals("min")) {
            min = HexType.parseHex(value);
            if(min==-1) throw new DatatypeException("incorrect value: "+value);
            return;
        }
        if(name.equals("max")) {
            max = HexType.parseHex(value);
            if(max==-1) throw new DatatypeException("incorrect value: "+value);
            return;
        }
        throw new DatatypeException("invalid parameter: "+name);
    }
}
